// Generated by LiveScript 1.6.0
(function(){
  var Cluster, mkdirp, path, extract, compList, importCwd, puppeteer, getTextAndHref, reqHandle, getTextTask, collect, extractor, out$ = typeof exports != 'undefined' && exports || this;
  Cluster = require('puppeteer-cluster').Cluster;
  mkdirp = require('mkdirp');
  path = require('path');
  extract = require('./util').extract;
  compList = require('./helper').compList;
  importCwd = require('import-cwd');
  puppeteer = importCwd('puppeteer');
  getTextAndHref = async function(page, url, fontName, scrollElementSelector, timeWait){
    var hasError, handle, scrollHeight, scrollTop, clientHeight, e, text, hrefs;
    (await page.goto(url, {
      waitUntil: 'networkidle2'
    }));
    hasError = false;
    if (scrollElementSelector) {
      try {
        do {
          (await page.waitFor(scrollElementSelector, {
            timeout: timeWait
          }));
          (await page.$eval(scrollElementSelector, fn$));
          handle = (await page.$(scrollElementSelector));
          scrollHeight = (await page.evaluate(fn1$, handle));
          scrollTop = (await page.evaluate(fn2$, handle));
          clientHeight = (await page.evaluate(fn3$, handle));
        } while (scrollHeight - scrollTop !== clientHeight);
      } catch (e$) {
        e = e$;
        hasError = true;
        console.info(e, url, scrollElementSelector);
      }
    }
    handle = new Function("eles", "return eles.filter((e)=> window.getComputedStyle(e).getPropertyValue(\"font-family\")\n.split(\",\").map( (x) => x.trim() )\n.includes('" + fontName + "'))\n.reduce( ( (p,c)=> p+= c.textContent ),\"\" )\n.split(\"\")\n.filter( (v,i,s)=> s.indexOf(v) === i )");
    if (scrollElementSelector && !hasError) {
      (await page.waitFor(timeWait));
    }
    text = (await page.$$eval("*", handle));
    hrefs = (await page.$$eval("a", function(l){
      return l.map(function(v){
        return v.href;
      });
    }));
    return [text, hrefs];
    function fn$(el){
      el.scrollTo(0, el.scrollHeight, {
        behavior: 'auto'
      });
    }
    function fn1$(e){
      return e.scrollHeight;
    }
    function fn2$(e){
      return e.scrollTop;
    }
    function fn3$(e){
      return e.clientHeight;
    }
  };
  reqHandle = function(req){
    if (req.resourceType() === 'image' || req.resourceType() === 'font') {
      return req.abort();
    } else {
      return req['continue']();
    }
  };
  getTextTask = async function(arg$){
    var page, data;
    page = arg$.page, data = arg$.data;
    (await page.setRequestInterception(true));
    page.setDefaultTimeout(6000);
    page.on('request', reqHandle);
    return (await getTextAndHref(page, data.url, data.fontName, data.scrollElementSelector, data.timeWait));
  };
  out$.collect = collect = async function(entry, fontName, scrollElement, timeWait, ppages){
    var preservedPages, cluster, ref$, text, hrefs, entryURL, entryNom, visited, pages, filtered, i$, len$, href, url, e, urlS, pp, p, tt, t;
    if (ppages) {
      preservedPages = compList(ppages).map(function(x){
        return new URL(x).toString();
      });
    }
    cluster = (await Cluster.launch({
      puppeteer: puppeteer,
      concurrency: Cluster.CONCURRENCY_CONTEXT
    }, {
      maxConcurrency: 4,
      puppeteerOptions: {
        args: ['--no-sandbox', '--disable-setuid-sandbox']
      }
    }));
    (await cluster.task(getTextTask));
    ref$ = (await cluster.execute({
      url: entry,
      fontName: fontName,
      scrollElementSelector: scrollElement,
      timeWait: timeWait
    })), text = ref$[0], hrefs = ref$[1];
    console.log(hrefs);
    if (preservedPages) {
      hrefs = hrefs.concat(preservedPages);
    }
    entryURL = new URL(entry);
    entryNom = entryURL.toString();
    visited = [entryNom];
    pages = [];
    filtered = hrefs.filter(function(x, i, s){
      return x.startsWith("http") && s.indexOf(x) === i;
    });
    for (i$ = 0, len$ = filtered.length; i$ < len$; ++i$) {
      href = filtered[i$];
      url = "";
      try {
        url = new URL(href);
      } catch (e$) {
        e = e$;
        continue;
      }
      urlS = url.toString();
      if (visited.indexOf(urlS) === -1 && url.origin === entryURL.origin) {
        pages.push(urlS);
      }
    }
    pp = [];
    while (p = pages.shift()) {
      pp.push(cluster.execute({
        url: p,
        fontName: fontName,
        scrollElementSelector: scrollElement,
        timeWait: timeWait
      }));
      visited.push(p);
    }
    tt = (await Promise.all(pp));
    for (i$ = 0, len$ = tt.length; i$ < len$; ++i$) {
      t = tt[i$];
      text = text.concat(t[0]);
    }
    text = text.filter(function(v, i, s){
      return deepEq$(s.indexOf(v), i, '===');
    });
    (await cluster.idle());
    (await cluster.close());
    return text;
  };
  out$.extractor = extractor = async function(config){
    var textArray, flat, words, transFont;
    textArray = (await collect(config.entry, config.fname, config.ss, config.sw, config.pages));
    flat = config.preserved.reduce(function(p, c, i){
      return p.concat(c.split(''));
    }, []).filter(function(value, index, self){
      return self.indexOf(value) === index;
    });
    words = flat.concat(textArray);
    console.log("collected size:" + textArray.length + "\n " + textArray);
    transFont = extract(config, words);
    mkdirp.sync(path.dirname(config.output));
    return transFont.output({
      path: config.output
    });
  };
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
